/**
*------------------------V3---------------------------
* This file is part of the Agora-Project Software package.
*
* @copyright (c) Agora-Project Limited <https://www.agora-project.net>
* @license GNU General Public License, version 2 (GPL-2.0)
*/


/*
 * INIT LA PAGE
 */
$(function(){
	pageLoadTimestamp=Date.now();//Microtime du chargement de la page
	extendJquery();				//Surcharge des fonctions Jquery
	mainPageDisplay();			//Menu flottant / largeur des blocks d'objet / clic sur les blocks d'objet / Gallerie d'image via LightBox / Etc.
	initContextMenu();			//Initialise les menus contextuels
	initTooltips();				//Initialize les infobulles (tooltip)
	inputControls();			//Controles de champs spécifiques (Datepickers, FileSize, etc.)
});

/*
 * Surcharge des fonctions Jquery (Fonctions étendues)
 */
function extendJquery()
{
	////	Vitesse (duration) par défaut des effets : "fadeIn()", "toggle()", etc
	$.fx.speeds._default=100;

	////	Verifie l'existance d'un element
	$.fn.exist=function(){
		return (this.length>0) ? true : false;
	};
	////	Verifie si l'element n'a pas de valeur ("empty") ...et aussi s'il existe
	$.fn.isEmpty=function(){
		return (this.length==0 || this.val().length==0) ? true : false;
	};
	////	Focus sur un champs surligné en rouge
	$.fn.focusRed=function(){
		this.addClass("focusRed").focus();
	};
	////	Affichage/masquage d'element : "surcharge" de fonctions de base de Jquery
	if(inIframe())
	{
		var fadeInBASIC=$.fn.fadeIn;
		var showBASIC=$.fn.show;
		var toggleBASIC=$.fn.toggle;
		var slideToggleBASIC=$.fn.slideToggle;
		var fadeToggleBASIC=$.fn.fadeToggle;
		$.fn.fadeIn=function(){			lightboxResize();	return fadeInBASIC.apply(this,arguments); };
		$.fn.show=function(){			lightboxResize();	return showBASIC.apply(this,arguments); };
		$.fn.toggle=function(){			lightboxResize();	return toggleBASIC.apply(this,arguments); };
		$.fn.slideToggle=function(){	lightboxResize();	return slideToggleBASIC.apply(this,arguments); };
		$.fn.fadeToggle=function(){		lightboxResize();	return fadeToggleBASIC.apply(this,arguments); };
	}
}

/*
 * PAGE INIT : Init les menus contextuels
 * chaque launcher (icone/texte/block d'objet) doit avoir la propriété "for" correspondant à l'ID du menu  &&  une class "menuLaunch" (sauf les launcher de block d'objet) 
 */
function initContextMenu()
{
	////	Mode Normal
	if(isMobile()==false){
		////	Mouseover/Click d'un "menu launcher" (icone/texte) : affiche le menu
		$(".menuLaunch").on("mouseover click",function(event){
			event.stopPropagation();//pour pas selectionner le block ".objContainer" ou ouvrir un evt de calMonth
			showContextMenu(this,event);//Affiche le menu context
		});
		////	Affiche via Click Droit sur le block de l'objet. "Return false" pour ne pas afficher le menu du browser
		$("[for^='objMenu_']").on("contextmenu",function(event){  showContextMenu(this,event);  return false;  });
		////	Arrête de survoler un menu contextuel : on le masque
		$(".contextMenu").on("mouseleave",function(){  $(this).slideUp(50);  });
		////	Survol le block d'un objet : Masque les menus contextuels qui ne le concernent pas
		$("[for^='objMenu_']").on("mouseenter",function(){  $(".contextMenu").not("#"+this.getAttribute("for")).slideUp(50);  });
		////	Click dans les menus. "stopPropagation()" pour pas selectionner le ".objContainer"
		$(".contextMenu,.objMiscMenus").click(function(event){  event.stopPropagation();  });
	}
	////	Mode responsive
	else{
		////	Click d'un "menu launcher" (icone/texte) : affiche le menu
		$(".menuLaunch").on("click",function(event){
			event.stopPropagation();//pour pas selectionner le block ".objContainer" ou ouvrir un evt de calMonth
			if($("#respMenuContent").is(":visible"))	{$("#"+this.getAttribute("for")).addClass("contextMenuSubMenu").slideToggle();}	//Affiche en tant que sous-menu si le menu responsive est déjà ouvert
			else										{showRespMenu(this.getAttribute("for"), this.getAttribute("forTwo"));}			//..Sinon on affiche le menu responsive
		});
		////	Click sur le "close" du menu
		$("#respMenuClose,#respMenuBg").on("click",function(){  hideRespMenu();  });
		////	Swipe sur la page : affiche/masque le menu responsive
		responsiveSwipe();
	}
}
/*
 * Affiche un menu contextuel (mode normal)
 */
function showContextMenu(thisLauncher, event)
{
	////	Récup l'Id du menu &  Spécifie la hauteur max du menu (fonction de la hauteur de page)
	var menuId="#"+$(thisLauncher).attr("for");
	$(menuId).css("max-height", Math.round($(window).height()-30)+"px");

	////	Position en fonction : de la position de la souris (click droit sur ".objContainer")  OU  de la position du launcher survolé
	if(event.type=="contextmenu")																				{var menuPosX=event.pageX - $(thisLauncher).offset().left;	var menuPosY=event.pageY - $(thisLauncher).offset().top;}//".objContainer" tjs en position relative/absolute : ajuste donc la position du menu car il doit être calculé en fonction du ".objContainer" et non de la page (cf. event.pageX et event.pageY)
	else if(/(msie|edge)/i.test(navigator.appVersion) && $(thisLauncher).parent().css("position")!="relative")	{var menuPosX=$(thisLauncher).offset().left;				var menuPosY=$(thisLauncher).offset().top;}/*Utiliser "offset()" pour un affichage normal des menus sous MS Edge*/
	else																										{var menuPosX=$(thisLauncher).position().left;				var menuPosY=$(thisLauncher).position().top;}

	////	Repositionne le menu s'il est au bord droit/bas de la page
	//Positions du menu + largeur/hauteur : bordure droite et bas du menu
	var menuRightPos =menuPosX + $(menuId).outerWidth(true);
	var menuBottomPos=menuPosY + $(menuId).outerHeight(true);
	//Parent ".objContainer" en position "relative"/"absolute" : ajoute sa position sur la page via "offset()"
	if(/(relative|absolute)/i.test($(menuId).parent().css("position"))){
		menuRightPos+=$(menuId).parent().offset().left;
		menuBottomPos+=$(menuId).parent().offset().top;
	}
	//Vérifie et ajuste si besoin la position si on est en bordure de page
	var posPageRight=$(window).width();
	var posPageBottom=$(window).height()+$(window).scrollTop();
	if(posPageRight < menuRightPos)		{menuPosX=menuPosX-(menuRightPos-posPageRight)-10;}
	if(posPageBottom < menuBottomPos)	{menuPosY=menuPosY-(menuBottomPos-posPageBottom)-10;}

	////	Positionne et affiche le menu  ..et ferme les autres menus
	if(event.type=="mouseover") {menuPosX-=3;	menuPosY-=3;}//Recentre le menu
	else						{menuPosX-=10;	menuPosY-=10;}//Menu contextuel : recentre un peu +
	$(menuId).css("left",parseInt(menuPosX)+"px").css("top",parseInt(menuPosY)+"px").slideDown(50);//pas "show(50)" (Pb si le menu est tt à droite de la page)
	$(".contextMenu").not(menuId).hide();
}
/*
 * Affiche le menu responsive
 */
function showRespMenu(forId, forTwoId)
{
	//Init
	curRespMenuOneId="#"+forId;
	curRespMenuTwoId=(typeof forTwoId=="string" && $("#"+forTwoId).exist())  ?  "#"+forTwoId  :  null;
	//Vérif bien que le menu existe
	if($(curRespMenuOneId).exist())
	{
		//Masque par défaut le conteneur "#respMenuContentOne/Two"
		$("#respMenuContentOne,#respMenuContentTwo").hide();
		//Déplace le contenu du menu dans le conteneur  ("appendTo" conserve les listeners par rapport à "html()")
		$(curRespMenuOneId+">*").appendTo("#respMenuContentOne");
		if(curRespMenuTwoId!=null)  {$(curRespMenuTwoId+">*").appendTo("#respMenuContentTwo");}
		//Affiche le menu et son contenu
		$("#respMenuBg,#respMenuMain,#respMenuContentOne,#respMenuContentTwo").show();
		//Désactive le scroll de page en arriere plan
		$("body").css("overflow","hidden");
	}
}
/*
 * Masque le menu responsive
 */
function hideRespMenu(){
	//Vérif bien que le menu est ouvert (car lancé aussi dès un swipe..)
	if($("#respMenuMain").is(":visible"))
	{
		//Masque le menu
		$("#respMenuBg,#respMenuMain,#respMenuContentOne,#respMenuContentTwo").hide();
		//Remet son contenu dans le div d'origine
		$("#respMenuContentOne>*").appendTo(curRespMenuOneId);
		if(curRespMenuTwoId!=null)  {$("#respMenuContentTwo>*").appendTo(curRespMenuTwoId);}
		//Réactive le scroll de page en arriere plan
		$("body").css("overflow","visible");
	}
}
/*
 * Swipe sur la page : affiche/masque le menu responsive
 */
function responsiveSwipe()
{
	//Debut/Fin du touch : valeurs de départ / réinit les valeurs
	document.addEventListener("touchstart",function(event){  xDown=event.touches[0].clientX;  });
	document.addEventListener("touchend",function(){  xDown=0;  });
	//Détecte le swipe
	document.addEventListener("touchmove",function(event){
		if(typeof xDown!="undefined")
		{
			//Menu des modules (appli)  ou  Menu principal (site public and co)
			if($("#headerModules").exist())			{var menuId="headerModules";}
			else if($("#headerMenuMain").exist())	{var menuId="headerMenuMain";}
			else									{var menuId=null;}
			if(menuId!=null){
				var isSwipeLeft =((xDown - event.touches[0].clientX) > 50);//50px de mouv. minimum
				var isSwipeRight=((xDown - event.touches[0].clientX) < -50);//idem
				//Swipe left à moins de 70px du bord droit : affiche le menu s'il n'est pas visible  ||  Swipe right et menu affiché : masque le menu
				if(isSwipeLeft==true && parseInt($(window).width()-xDown)<70)	{showRespMenu(menuId,"pageModMenu");}
				else if(isSwipeRight==true)										{hideRespMenu();}
			}
		}
	});
}

/*
 * PAGE INIT : Init les tooltips avec Tooltipster (cf. attribut "title")
 */
function initTooltips()
{
	//Options dans une variable, pour pouvoir réinitialiser un tooltip. "multiple" pour pouvoir afficher le tooltip par défaut
	tooltipsterOptions={contentAsHTML:true, multiple:true, position:"bottom", maxWidth:400, theme:"tooltipster-shadow"};
	tooltipsterOptionsBis=jQuery.extend({},tooltipsterOptions);//Clone "tooltipsterOptions" avec "jQuery.extend()"...
	tooltipsterOptionsBis.interactive=true;//...et ajoute l'option "interactive" pour pouvoir cliquer sur les liens (descriptions de dossier & co)
	//Lance le tooltip (même responsive)
	$("[title]").not(".noTooltip,[title=''],[title*='http']").tooltipster(tooltipsterOptions);//Tooltips normaux
	$("[title*='http']").tooltipster(tooltipsterOptionsBis);//Tooltip avec liens "http"
}

/*
 * Initialise les controles de champs -> Datepickers, FileSize controls, Integer, etc
 */
function inputControls()
{
	////	Formulaire modifié : passe "confirmCloseForm" à "true" pour la confirmation de fermeture (".confirmCloseOff" : sauf les forms de connexion and co. Ajoute "parent" pour cibler les "form" de lightbox)
	setTimeout(function(){
		$("form:not(.confirmCloseOff) input, form select, form textarea").on("change keyup",function(){ parent.confirmCloseForm=true; });
	},500);//500ms après l'init et préremplissage du formulaire

	////	Init le Datepicker jquery-UI
	$(".dateInput, .dateBegin, .dateEnd").datepicker({
		dateFormat:"dd/mm/yy",
		firstDay:1,
		showOtherMonths: true,
		selectOtherMonths: true,
		onSelect:function(date){
			//Select .dateBegin -> bloque la date minimum de .dateEnd (mais pas inversement!)
			if($(this).hasClass("dateBegin"))	{$(".dateEnd").datepicker("option","minDate",date);}
			//Trigger sur le champ concerné pour continuer l'action
			$(this).trigger("change");
		}
	});

	////	Init le plugin Timepicker (jquery-UI)
	if(jQuery().timepicker){
		var timepickerMinutesStep=(isMobile())  ?  5  :  15;//Palier de 5mn en "responsive", car champs en "readonly"
		$(".timeBegin, .timeEnd").timepicker({timeFormat:"H:i", step:timepickerMinutesStep});
	}

	////	Readonly sur les datepickers et timepickers
	if(isMobile())	{$(".dateInput,.dateBegin,.dateEnd,.timeBegin,.timeEnd").attr("readonly","readonly").css("background-color","white");}

	////	Controle les dates de début/fin
	$(".dateBegin, .dateEnd, .timeBegin, .timeEnd").change(function(){
		//Masque le champ H:M?
		if($(this).hasClass("dateBegin") || $(this).hasClass("dateEnd")){
			var timeClass=$(this).hasClass("dateBegin") ? ".timeBegin" : ".timeEnd";
			if($(this).isEmpty()==false)	{$(timeClass).show();}
			else							{$(timeClass).hide();  $(timeClass).val(null);}
		}
		//Controle des date/time
		if($(".dateBegin").isEmpty()==false || $(".dateEnd").isEmpty()==false)
		{
			//Controle des "H:M"
			if($(this).hasClass("timeBegin") || $(this).hasClass("timeEnd"))
			{
				//Champ à controler
				var timeClass=$(this).hasClass("timeBegin") ? ".timeBegin" : ".timeEnd";
				//controle Regex des H:M
				var timeRegex=/^[0-2][0-9][:][0-5][0-9]$/;
				if($(timeClass).isEmpty()==false && timeRegex.test($(timeClass).val())==false){
					notify("H:m error");
					$(timeClass).val(null);
					return false;
				}
				//précise H:M de fin si vide et début précisé
				if($(".timeEnd").isEmpty())  {$(".timeEnd").val($(".timeBegin").val());}
			}
			//Début après Fin : message d'erreur
			if($(".dateBegin").isEmpty()==false && $(".dateEnd").isEmpty()==false)
			{
				var timestampBegin=$(".dateBegin").datepicker("getDate").getTime()/1000;//getTime() renvoie des millisecondes..
				var timestampEnd=$(".dateEnd").datepicker("getDate").getTime()/1000;//idem
				if($(".timeBegin").isEmpty()==false)	{var hourMinute=$(".timeBegin").val().split(":");	timestampBegin=timestampBegin + (hourMinute[0]*3600) + (hourMinute[1]*60);}
				if($(".timeEnd").isEmpty()==false)		{var hourMinute=$(".timeEnd").val().split(":");		timestampEnd=timestampEnd + (hourMinute[0]*3600) + (hourMinute[1]*60);}
				if(timestampBegin > timestampEnd)
				{
					//Date/heure de fin reculé : message d'erreur
					if($(this).hasClass("dateEnd") || $(this).hasClass("timeEnd"))	{notify(parent.labelDateBeginEndControl);}
					//Modif la date/heure de fin ("setTimeout" pour éviter une re-modif du timePicker)
					setTimeout(function(){
						$(".dateEnd").val($(".dateBegin").val());
						$(".timeEnd").val($(".timeBegin").val());
					},500);
				}
			}
		}
	});

	////	Controle la taille des fichiers des inputs "file"
	$("input[type='file']").change(function(){
		if($(this).isEmpty()==false && this.files[0].size > parent.valueUploadMaxFilesize){
			$(this).val("");
			notify(parent.labelUploadMaxFilesize);
		}
	});

	////	Affecte une couleur à un input "select" (chaque option doit avoir un attribut "data-color")
	$("select option").each(function(){
		if(this.getAttribute("data-color"))  {$(this).css("background-color",this.getAttribute("data-color")).css("color","#fff");}
	});
	$("select").change(function(){
		var optionColor=$(this).find("option:selected").attr("data-color");
		if(isEmptyValue(optionColor)==false)	{$(this).css("background-color",optionColor).css("color","#fff");}
		else									{$(this).css("background-color","#fff").css("color","#000");}
	});
	
	////	Pas d'autocomplétion sur les inputs "Password"
	$("input[type='password']").attr("autocomplete","off");
}

/*
 * Controle s'il s'agit d'un mail
 */
function isMail(mail)
{
	var mailRegex=/^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	return mailRegex.test(mail);
}

/*
 * Controle la validité d'un password : au moins 6 caractères && au moins un chiffre && au moins une lettre
 */
function isValidPassword(password)
{
	return (password.length>=6 && /[0-9]/.test(password) && /[a-z]/i.test(password));
}

/*
 * Cherche une expression dans une chaine de caracteres
 */
function find(needle, haystack)
{
	//Convertir en texte puis en minuscule : recherche la position de needle dans haystack
	if(typeof haystack!="undefined")	{return (haystack.toString().toLowerCase().indexOf( needle.toString().toLowerCase() ) >= 0) ? true : false;}
}

/*
 * Affiche un message de notification (via le plugin Jquery "toastmessage")
 */
function notify(message, typeNotif)
{
	//Type de notification :  "success" vert  /  "warning" jaune  /  "notice" bleu (par défaut)
	var typeNotif=(typeof typeNotif!="undefined")  ?  typeNotif  :  "notice";
	//Temps d'affichage de la notification  (1 seconde pour 10 caracteres & 5 secondes minimum)
	var stayTime=parseInt(message.length/10);
	if(stayTime<5)  {stayTime=5;}
	//Affiche la notification
	parent.$().toastmessage("showToast",{
		text		: message,
		type		: typeNotif,
		position	: "top-center",
		stayTime	: (stayTime*1000)//stayTime en microsecondes
	});
}

/*
 * Redirection page
 */
function redir(adress, redirMainPage)
{
	//On annule la fermeture d'un formulaire en cours d'édition ?
	if(closeFormCanceled())  {return false;}
	//Redirection de la page principale OU d'une lightbox
	if(redirMainPage===true)	{window.parent.location.href=adress;}
	else						{window.location.href=adress;}
}


/*
 * Annule la fermeture du formulaire en cours ?  Exple : édition d'element dans une lightbox  OU  édition d'une newsletter en page principale
 */
function closeFormCanceled()
{
	if(typeof parent.confirmCloseForm!="undefined" && typeof parent.labelConfirmCloseForm!="undefined" && parent.confirmCloseForm==true){
		if(confirm(parent.labelConfirmCloseForm)==false)	{return true;}//Annule la fermeture du formulaire
		else												{parent.confirmCloseForm=false;}//On ferme le formulaire, puis réinit le "confirmCloseForm" pour éviter un nouveau "confirm()" via un "redir()"
	}
}

/*
 * Lancé depuis une iframe ?
 */
function inIframe()
{
	return (window.parent && window.parent.location!=window.location);
}

/*
 * Ouvre une lightbox via une fonction (et non des "href" : plus souple + n'interfère pas avec "stopPropagation()" des "contextMenu")
 * tests : edit object, open pdf/mp3, open mp4/webm, open userMap, open inline html
 */
function lightboxOpen(urlSrc)
{
	////	DEPUIS LIGHTBOX / PDF EN RESPONSIVE OU DEPUIS IE
	if(inIframe())																			{parent.lightboxOpen(urlSrc);}
	else if(/pdf$/i.test(urlSrc) && (isMobile() || find("Trident",navigator.appVersion)))	{window.open(urlSrc);}
	////	MP3 / VIDEO
	else if(/(mp3|mp4|webm)$/i.test(urlSrc))
	{
		//MP3 OU VIDEO (tester aussi en responsive)
		if(/mp3$/i.test(urlSrc))	{var urlSrcBis='<div style="padding:45px;"><audio id="lightboxMedia" controls><source src="'+urlSrc+'" type="audio/mpeg">HTML5 is required</audio></div>';}
		else						{var urlSrcBis='<video id="lightboxMedia" controls><source src="'+urlSrc+'" type="video/'+extension(urlSrc)+'">HTML5 is required</video>';}
		//Ouverture du player Audio/Video
		$.fancybox.open({
			type:"inline",
			src:urlSrcBis,
			opts:{
				buttons:[],//mini bouton 'close' déjà affiché par défaut..
				afterShow:function(){
					$.fancybox.getInstance().update();//Dimentionne le lightbox en fonction du contenu
					$("#lightboxMedia").get(0).play();//Lance la lecture auto (pas dans la balise <video> car sinon la lecture continue à la fermeture du lightbox)
				}
			}
		});
	}
	////	IFRAME
	else
	{
		$.fancybox.open({
			type:"iframe",
			src:urlSrc,
			opts:{
				buttons:['close'],//Affiche uniquement le bouton "close"
				autoFocus:false,//Pas de focus automatique sur le 1er element du formulaire!
				afterShow:function(){
					$.fancybox.getInstance().update();//Dimentionne le lightbox en fonction du contenu
				},
				beforeClose:function(){
					if(closeFormCanceled())  {return false;}//Annule la fermeture du formulaire?
				}
			}
		});
	}
}

/*
 * Width d'une Lightbox : appelé depuis une lightbox!
 */
function lightboxSetWidth(iframeBodyWidth)
{
	$(function(){
		if(find("px",iframeBodyWidth))		{iframeBodyWidth=iframeBodyWidth.replace("px","");}									//Width toujours en pixel
		else if(find("%",iframeBodyWidth))	{iframeBodyWidth=($(window.parent).width()/100) * iframeBodyWidth.replace("%","");}	//Idem
		if(iframeBodyWidth>$(window.parent).width())  {iframeBodyWidth=$(window.parent).width();}//Width du contenu > Width de la page : le width devient celui de la page "parent"
		//Définie le "max-width" de l'iframe (pas "width", car affiche un scroll horizontal en 1366x900)
		if(isEmptyValue(iframeBodyWidth)==false)  {$("body").css("max-width",parseInt(iframeBodyWidth));}
	});
}

/*
 * Agrandit si besoin la hauteur d'une Lightbox :  Suite à un fadeIn(), FadeOut(), etc  OU  au chargement du TinyMce
 */
function lightboxResize()
{
	//Resize si le lightbox est visible
	if(typeof parent.$.fancybox!="undefined" && parent.$(".fancybox-container").is(":visible"))
	{
		//Annule le dernier "setTimeout", pour ne pas les cumuler
		if(typeof lightboxResizeTimeout!="undefined")  {clearTimeout(lightboxResizeTimeout);}
		//Ajoute un timeout de 300ms minimum (le temps d'un "fadeIn" ou autre : cf. "$.fx.speeds._default" à 100ms)
		lightboxResizeTimeout=setTimeout(function(){
			//Resize uniquement s'il y a augmentation de la hauteur (pas si ya diminution: évite ainsi les resizes trop fréquents)
			var lightboxHeightNew=(inIframe())  ?  parent.$(".fancybox-iframe").contents().height()  :  $(".fancybox-inner").contents().height();//Opérateur ternaire pour Firefox..
			if(typeof lightboxHeightOld=="undefined" || lightboxHeightNew > lightboxHeightOld){
				lightboxHeightOld=lightboxHeightNew;//MAJ du "lightboxHeightOld" qu'on garde en référence
				parent.$.fancybox.getInstance().update();//lance l'update!
			}
		},300);
	}
}

/*
 * Ferme le lightbox & reload la page principale (appelé depuis le lightbox)
 */
function lightboxClose(urlSpecific, urlMoreParms)
{
	var reloadUrl=(!isEmptyValue(urlSpecific))  ?  urlSpecific  :  window.parent.location.href;			//Url passée en parametre OU Url de "parent"
	if(find("msgNotif",reloadUrl))	{reloadUrl=reloadUrl.substring(0,reloadUrl.indexOf('&msgNotif'));}	//Enlève si besoin les parametres "msgNotif" déjà présents dans la page principale
	if(!isEmptyValue(urlMoreParms))	{reloadUrl+=urlMoreParms;}											//Ajoute si besoin de nouveaux parametres ("msgNotif" ou autre)
	window.parent.location.replace(reloadUrl);															//Reload la page principale
}

/*
 * Navigation sur appareil tactile (PHP && COMMON.JS && COMMON.CSS : width de 1005px maxi)
 */
function isMobile()
{
	return (/android|iphone|ipad|blackberry|windows phone|tablet|touch/i.test(navigator.userAgent)	||	parent.document.body.clientWidth<=1005);
}

/*
 * Confirmer une suppression puis rediriger pour effectuer la suppresion
 */
function confirmDelete(redirUrl, labelConfirmDeleteDbl, ajaxControlUrl, ajaxConfirmLabel)
{
	//Effectue un controle Ajax?
	if(isEmptyValue(ajaxControlUrl)==false){
		var ajaxResult=$.ajax({url:ajaxControlUrl,async:false}).responseText;//Attend la réponse Ajax pour passer à la suite (async:false)
		if(ajaxResult!="true" && confirm(ajaxConfirmLabel)==false)	{return false;}//exple : "Attention! certains sous-dossiers ne vous sont pas accessibles en lecture.."
	}
	//Lance la suppression? ("labelConfirmDelete" : cf. "VueStructure.php")
	if(confirm(parent.labelConfirmDelete)){
		if(isEmptyValue(labelConfirmDeleteDbl)==false && confirm(labelConfirmDeleteDbl)==false)  {return false;}
		redir(redirUrl);
	}
}

/*
 * Scroll vers un element OU en bas de page
 */
function toScroll(thisSelector)
{
	//Scroll si la page ne vient pas d'être chargé
	if(alreadyLoadedPage()){
		var heightReference=(typeof thisSelector!="undefined" && $(thisSelector).exist())  ?  $(thisSelector).position().top  :  $(document).height();
		$("html,body").animate({scrollTop:heightReference},100);
	}
}

/*
 * Extension d'un fichier (sans le point!)
 */
function extension(fileName)
{
	if(isEmptyValue(fileName)==false)	{return fileName.split('.').pop().toLowerCase();}
}

/*
 * Vérifie si une chaine est au format Json (cf. Omnispace)
 */
function isJsonString(string)
{
	try{
		JSON.parse(string);
	}catch(e){
		return false;
	}
	return true;
}

/*
 * Vérifie si une valeure est "empty" (équivalent à php)
 */
function isEmptyValue(value)
{
	return (value==null || typeof value=="undefined" || value=="" || value==0);
}

/*
 * La page ne vient pas d'être chargée à l'instant
 */
function alreadyLoadedPage()
{
	return ((Date.now()-pageLoadTimestamp)>1500);//1500ms minimum!
}


/***************************************************************************************************************************/
/*******************************************	SPECIFIC METHODS	********************************************************/
/***************************************************************************************************************************/


/*
 * Contrôle de connexion à l'agora
 */
function controlConnect()
{
	var inputLogin=$("[name=connectLogin]");
	var inputPassword=$("[name=connectPassword]");
	if(inputLogin.isEmpty() || inputLogin.val()==inputLogin.attr("placeholder") || inputPassword.isEmpty() || inputPassword.val()==inputPassword.attr("placeholder")){
		notify(parent.labelSpecifyLoginPassword);
		return false;
	}
}

/*
 * PAGE INIT : Initialise l'affichage des pages principales
 * => Menu flottant / Largeur des blocks d'objet / Clic sur les blocks d'objet / Etc.
 */
function mainPageDisplay()
{
	////	Largeur des objets en affichage "block", en fonction de la largeur de la page
	if($(".objBlocks .objContainer").length>0)
	{
		//Marge & Largeur min/max des objets
		var objMargin=parseInt($(".objContainer").css("margin-right"))+1;
		var objMinWidth=parseInt($(".objContainer").css("min-width"));
		var objMaxWidth=parseInt($(".objContainer").css("max-width")) + objMargin;//ajoute la marge pour l'application du "width()"
		//Largeur disponible
		var containerWidth=$(".pageFullContent").width();//pas de "innerWidth()" car cela ajoute le "padding"
		if(isMobile()==false && $(document).height()==$(window).height())	{containerWidth=containerWidth-18;}//pas encore d'ascenseur : anticipe son apparition (sauf en responsive ou l'ascenseur est masqué)
		//Calcul la largeur des objets
		var objWidth=null;
		var lineNbObjects=Math.ceil(containerWidth / objMaxWidth);//Nb maxi d'objets par ligne
		if(containerWidth < (objMinWidth*2))				{objWidth=containerWidth;  $(".objContainer").css("max-width",containerWidth);}	//On peut afficher qu'un objet par ligne : il prendra la largeur du conteneur
		else if($(".objContainer").length<lineNbObjects)	{objWidth=objMaxWidth;}															//Nb d'objets insuffisant pour remplir la 1ère ligne : il prendra sa largeur maxi
		else												{objWidth=Math.floor(containerWidth/lineNbObjects);}							//Sinon on calcul : fonction du conteneur et du nb d'objets par ligne
		//Applique la largeur des blocks (enlève le margin: pas pris en compte par le "outerWidth")  &&  Rend visible si ce n'est pas le cas !!
		$(".objContainer").outerWidth(Math.round(objWidth-objMargin)+"px");
	}
	//Raffiche après calcul ci-dessus du width des ".objContainer" (".objBlocks" masqués par défaut via "common.css")
	$(".objBlocks").css("visibility","visible");

	////	Click/DblClick sur les blocks conteneurs des objets : Sélectionne/Edite l'objet
	if($(".objContainer").exist())
	{
		//Pas sur mobile
		if(isMobile()==false)
		{
			//Trigger si ya click sur le block et que les actions par défaut sont autorisées (cf. "noClickAction")
			$(".objContainer:not(.noClickAction)").click(function(){
				//Init
				var blockId="#"+this.id;
				timeDblClick=400;//intervalle entre 2 clics
				if(typeof timeLastClick=="undefined")	{timeLastClick=Date.now();  containerIdLastClick=this.id;}
				//Double click?
				diffNowAndLastClick=(Date.now()-timeLastClick);
				var isDblClick=(diffNowAndLastClick>10 && diffNowAndLastClick<timeDblClick && containerIdLastClick==this.id);
				//Action sur l'objet
				if(isDblClick==true && $(blockId).attr("data-urlEdit"))				{lightboxOpen($(blockId).attr("data-urlEdit"));}//dblClick + "data-urlEdit" => édition d'objet
				else if(isDblClick==false && typeof parent.objSelect=="function")	{parent.objSelect(this.id);}					//click + fonction "objSelect()" => lance la fonction (cf. "VueObjMenuSelection.php")
				//Update "lastClickTime" & "containerIdLastClick"
				timeLastClick=Date.now();
				containerIdLastClick=this.id;
			});
		}
	}

	////	Menu flottant du module (à gauche)
	if(isMobile()==false && $(".pageModMenuContainer").exist())
	{
		var pageMenuPos=$(".pageModMenuContainer").position();
		$(window).scroll(function(){
			var pageMenuHeight=pageMenuPos.top;//Init la position top du menu
			$(".pageModMenuContainer").children().each(function(){ pageMenuHeight+=$(this).outerHeight(true); });//hauteur de chaque element
			if(pageMenuHeight < $(window).height())  {$(".pageModMenuContainer").css("padding-top",$(window).scrollTop()+"px");}
		});
	}

	////	Fancybox des images & Fancybox inline (html) & Visibilite des objets & du footer (finalise l'affichage)
	var fancyboxImagesButtons=(isMobile()) ? ['close'] : ['fullScreen','thumbs','close'];
	$("[data-fancybox='images']").fancybox({buttons:fancyboxImagesButtons});
	$("[data-fancybox='inline']").fancybox({touch:false,arrows:false,infobar:false,smallBtn:false,buttons:['close']});//Pas de navigation entre les elements "inline" ("touch","arrow","infobar"). Pas de "smallBtn" close, mais plutôt celui en haut à droite.
	$("#pageFooterHtml").css("max-width", parseInt($(window).width()-$("#pageFooterIcon").width()-20));//Pour que "pageFooterHtml" ne se superpose pas à "pageFooterIcon"
	setTimeout(function(){  $(".pageFull,.pageCenter").css("margin-bottom",footerHeight());  },300);//Marge sous le contenu pour qu'il ne soit pas masqué par le Footer. Timeout car pour récupérer "footerHeight()" il faut que le "#livecounterMain" soit chargé via Ajax..

	////	Resize de la page : relance récursivement la fonction "mainPageDisplay()"
	if(!isMobile() && !alreadyLoadedPage()){
		$(window).resize(function(){
			if(typeof mainPageDisplayTimeout!="undefined")  {clearTimeout(mainPageDisplayTimeout);}//annule le dernier "setTimeout" (pas de cumul)
			mainPageDisplayTimeout=setTimeout(function(){ mainPageDisplay(); },500);
		});
	}
}

/*
 * Calcul la hauteur disponible pour le contenu principal de la page
 */
function availableContentHeight()
{
	//Height de la fenêtre (mais pas la page), moins la Position "top" du conteneur, moins le paddingTop du conteneur, moins le paddingBottom du conteneur, moins le Height du footer
	var containerSelectors=".pageCenterContent,.pageFullContent,.emptyContainer";
	return Math.round($(window).height() - $(containerSelectors).offset().top - parseInt($(containerSelectors).css("padding-top")) - parseInt($(containerSelectors).css("padding-bottom")) - footerHeight());
}

/*
 * Calcul la hauteur du footer
 */
function footerHeight()
{
	//Icone du footer / Text html du footer  /  LivecounterMain (recup la hauteur préétablie via CSS, le contenu du livecounter est chargé après via Ajax)
	var footerHeightTmp=0;
	$("#pageFooterHtml:visible,#pageFooterIcon:visible,#livecounterMain:visible").each(function(){
		if($(this).html().length>0 && footerHeightTmp<$(this).outerHeight(true))  {footerHeightTmp=$(this).outerHeight(true);}//controle la length, car le "pageFooterHtml" peut être vide mais affiché..
	});
	return footerHeightTmp+2;//+ 2px de marge (cf. "blox-shadow" des blocs)
}

/*
 * Confirmation (ou pas) d'événement
 */
function proposedEventConfirm(_idCal, _idEvt, proposedEventDivId)
{
	//Init
	var confirmed=false;
	var ajaxUrl="?ctrl=calendar&action=proposedEventConfirm&targetObjId=calendar-"+_idCal+"&_idEvt="+_idEvt;
	//Demande de confirmation
	if(confirm(parent.labelEvtConfirm))			{ajaxUrl+="&confirmed=1";  confirmed=true;}//Evt ajouté
	else if(confirm(parent.labelEvtConfirmNot))	{ajaxUrl+="&confirmed=0";  confirmed=true;}//Evt rejeté (propostion refusée)
	//Lance la requête en Ajax
	if(confirmed==true){
		$.ajax(ajaxUrl).done(function(ajaxResult){
			//Recharge la page et le calendrier
			if(getUrlParam("ctrl",window.location.href)=="calendar")  {redir("?ctrl=calendar");}
			//Masque la proposition d'evt et masque tout le menu si ya plus aucune proposition
			else{
				$("#"+proposedEventDivId).hide();
				if($("#proposedEventList li:visible").length==0)  {$("#proposedEventLabel,#proposedEventList").hide();}
			}
		});
	}
}

/*
 * Affectations des Spaces<->Users : userEdit OU spaceEdit (Click de Label/Checkbox)
 */
function initSpaceAffectations()
{
	//Click de Label
	$(".spaceAffectLine label").click(function(){
		//init
		var _idTarget=$(this).parent().attr("id").replace("targetLine","");//le "targetLine" est le "parent" du label
		var box1="input[name='spaceAffect[]'][value='"+_idTarget+"_1']";
		var box2="input[name='spaceAffect[]'][value='"+_idTarget+"_2']";
		//Bascule les checkboxes
		var boxToCheck=null;
		if($(box1).prop("disabled")==false && $(box1).prop("checked")==false && $(box2).prop("checked")==false)	{boxToCheck=box1;}
		else if($(box1).prop("checked") && $(box2).prop("checked")==false)										{boxToCheck=box2;}
		//Uncheck toutes les boxes (sauf disabled)
		$("input[name='spaceAffect[]'][value^='"+_idTarget+"_']:not(:disabled)").prop("checked",false);
		//Check la box sélectionnée && stylise le label
		if(boxToCheck!=null)  {$(boxToCheck).prop("checked",true);}
		spaceAffectStyle();
	});
	//Click de Checkbox
	$(".spaceAffectLine :checkbox").change(function(){
		var targetId=this.value.split("_")[0];//"55_2" : récup l'idSpace/idUser "55"
		$("[name='spaceAffect[]'][value^='"+targetId+"_']:not(:disabled)").not(this).prop("checked",false);//"uncheck" les autres box (sauf disabled)
		spaceAffectStyle();//stylise le label
	});
	//Init le style des labels
	spaceAffectStyle();
};

/*
 * Applique un style aux labels avec une checkbox cochée
 */
function spaceAffectStyle()
{
	//Réinit le style des affectations
	$(".spaceAffectLine").removeClass("sTableRowSelect sAccessRead sAccessWrite");
	//Stylise les labels && la ligne sélectionnées
	$("input[name='spaceAffect[]']:checked").each(function(){
		//"55_2" : récup l'idSpace/idUser "55" et le droit "2"
		var targetId   =this.value.split("_")[0];
		var targetRight=this.value.split("_")[1];
		//Stylise la ligne
		if(targetRight=="2")		{$("#targetLine"+targetId).addClass("sTableRowSelect sAccessWrite");}
		else if(targetRight=="1")	{$("#targetLine"+targetId).addClass("sTableRowSelect sAccessRead");}
	});
}

/*
 * Récupère dans une Url la valeur d'un parametre
 */
function getUrlParam(paramName, url)
{
	paramName=paramName.replace(/[\[\]]/g, "\\$&");
	var regex=new RegExp("[?&]"+paramName+"(=([^&#]*)|&|#|$)");
	var results=regex.exec(url);
	if(!results)			{return null;}
	else if(!results[2])	{return '';}
	else					{return decodeURIComponent(results[2].replace(/\+/g," "));}
}

/*
 * Valide le "like"/"dontlike" d'un objet
 */
function usersLikeValidate(targetObjId, likeValue)
{
	if(isEmptyValue(targetObjId)==false && isEmptyValue(likeValue)==false)
	{
		//Requête Ajax
		$.getJSON("?ctrl=object&action=UsersLikeValidate&targetObjId="+targetObjId+"&likeValue="+likeValue).done(function(jsonResult){
			//Init les id
			var idLike			="#likeMenu_"+targetObjId+"_like";
			var idDontlike		="#likeMenu_"+targetObjId+"_dontlike";
			var idCircleLike    =idLike+" .objMiscMenuCircle";
			var idCircleDontlike=idDontlike+" .objMiscMenuCircle";
			//Nb de likes/dontlikes dans les cercles
			$(idCircleLike+", "+idCircleDontlike).addClass("objMiscMenuCircleHide");//Réinit (Masque par défaut)
			if(parseInt(jsonResult.nbLikes)>0)		{$(idCircleLike).removeClass("objMiscMenuCircleHide").html(jsonResult.nbLikes);}
			if(parseInt(jsonResult.nbDontlikes)>0)	{$(idCircleDontlike).removeClass("objMiscMenuCircleHide").html(jsonResult.nbDontlikes);}
			//Liste des users dans les tooltip/title
			$(idLike).tooltipster("destroy").attr("title",jsonResult.usersLikeList).tooltipster(tooltipsterOptions);
			$(idDontlike).tooltipster("destroy").attr("title",jsonResult.usersDontlikeList).tooltipster(tooltipsterOptions);
			//Fait clignoter le like/dontlike  &&  affiche le tooltip (trigger mouseover)
			var menuId=(likeValue=="like") ? idLike : idDontlike;
			$(menuId).effect("pulsate",{times:1},300).trigger("mouseover");
			//Enlève/Ajoute l'opacité du menu (affichage Block, cf. css)
			if(jsonResult.nbLikes>0 || jsonResult.nbDontlikes>0)	{$(menuId).parent().removeClass("hideMiscMenu");}
			else													{$(menuId).parent().addClass("hideMiscMenu");}
		});
	}
}